<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SeatEquipment ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SeatEquipment extends AbstractStructArrayBase
{
    /**
     * The SeatEquipment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SeatEquipment[]
     */
    public $SeatEquipment;
    /**
     * Constructor method for ArrayOfJP_SeatEquipment
     * @uses ArrayOfJP_SeatEquipment::setSeatEquipment()
     * @param \StructType\JP_SeatEquipment[] $seatEquipment
     */
    public function __construct(array $seatEquipment = array())
    {
        $this
            ->setSeatEquipment($seatEquipment);
    }
    /**
     * Get SeatEquipment value
     * @return \StructType\JP_SeatEquipment[]|null
     */
    public function getSeatEquipment()
    {
        return $this->SeatEquipment;
    }
    /**
     * Set SeatEquipment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SeatEquipment[] $seatEquipment
     * @return \ArrayType\ArrayOfJP_SeatEquipment
     */
    public function setSeatEquipment(array $seatEquipment = array())
    {
        foreach ($seatEquipment as $arrayOfJP_SeatEquipmentSeatEquipmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SeatEquipmentSeatEquipmentItem instanceof \StructType\JP_SeatEquipment) {
                throw new \InvalidArgumentException(sprintf('The SeatEquipment property can only contain items of \StructType\JP_SeatEquipment, "%s" given', is_object($arrayOfJP_SeatEquipmentSeatEquipmentItem) ? get_class($arrayOfJP_SeatEquipmentSeatEquipmentItem) : gettype($arrayOfJP_SeatEquipmentSeatEquipmentItem)), __LINE__);
            }
        }
        $this->SeatEquipment = $seatEquipment;
        return $this;
    }
    /**
     * Add item to SeatEquipment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SeatEquipment $item
     * @return \ArrayType\ArrayOfJP_SeatEquipment
     */
    public function addToSeatEquipment(\StructType\JP_SeatEquipment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SeatEquipment) {
            throw new \InvalidArgumentException(sprintf('The SeatEquipment property can only contain items of \StructType\JP_SeatEquipment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SeatEquipment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SeatEquipment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SeatEquipment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SeatEquipment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SeatEquipment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SeatEquipment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatEquipment
     */
    public function getAttributeName()
    {
        return 'SeatEquipment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_SeatEquipment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
